#!/bin/ksh

[ $AAPP_PREFIX ] || { echo "AAPP_PREFIX is not defined"; exit; }
[ -d "$AAPP_PREFIX" ] || { echo "AAPP_PREFIX is not a directory"; exit; }

. $AAPP_PREFIX/ATOVS_CONF

file_identifier=$1     #optional - first part of file name e.g. iasi

infiles_dir=$PWD/infiles
decoded_dir_bufrdc=$PWD/bufrdc_decoded
decoded_dir_eccodes=$PWD/eccodes_decoded
set -x

cd $infiles_dir
for file in ${file_identifier}*.l?c; do
  convert_to_hdf5 -c $file
done

if [ -d $decoded_dir_bufrdc ]; then
  cd $decoded_dir_bufrdc
  for file in ${file_identifier}*.l?c; do
    convert_to_hdf5 -c $file
    h5diff ${file}.h5 $infiles_dir/${file}.h5 >${file}.h5.diff_infiles
    h5diff -v ${file}.h5 $infiles_dir/${file}.h5 >>${file}.h5.diff_infiles
  done
  echo "see difference files in $decoded_dir_bufrdc"
fi

if [ -d $decoded_dir_eccodes ]; then
  cd $decoded_dir_eccodes
  for file in ${file_identifier}*.l?c; do
    convert_to_hdf5 -c $file
    h5diff ${file}.h5 $infiles_dir/${file}.h5 >${file}.h5.diff_infiles
    h5diff -v ${file}.h5 $infiles_dir/${file}.h5 >>${file}.h5.diff_infiles
    if [ -d $decoded_dir_bufrdc ] && [ -f $decoded_dir_bufrdc/${file}.h5 ]; then
      h5diff ${file}.h5 $decoded_dir_bufrdc/${file}.h5 >${file}.h5.diff_bufrdc
      h5diff -v ${file}.h5 $decoded_dir_bufrdc/${file}.h5 >>${file}.h5.diff_bufrdc
    fi
  done
  echo "see difference files in $decoded_dir_eccodes"
fi
